package com.hzya.frame.seeyon.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.map.MapBuilder;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.dd.IDDInterfaceService;
import com.hzya.frame.seeyon.dao.ISeeYonInterFaceDao;
import com.hzya.frame.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.seeyon.entity.SeeYonInterFaceEntity;
import com.hzya.frame.seeyon.service.ISeeYonInterFace;
import com.hzya.frame.sysnew.application.api.entity.SysApplicationApiEntity;
import com.hzya.frame.sysnew.application.api.service.ISysApplicationApiService;
import com.hzya.frame.sysnew.application.database.dao.ISysApplicationDatabaseDao;
import com.hzya.frame.sysnew.application.database.entity.SysApplicationDatabaseEntity;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author 👻👻👻👻👻👻👻👻👻👻 gjh
 * @version 1.0
 * @content
 * @date 2023-08-22 9:30
 */
@Service(value = "seeYonInterFace")
public class SeeYonInterFaceImpl implements ISeeYonInterFace {
    private static final Logger logger = LoggerFactory.getLogger(SeeYonInterFaceImpl.class);
    /*** rest 用户名*/
    private static final String RESTUSERNAME = "hzyaRest";
    /*** rest 密码*/
    private static final String RESTPASSWORD = "a5ce21b8-91db-4cec-b3e3-3e44719655fd";
    // TODO 此处URL暂时写死，后续根据传递的应用ID获取
    private static final String sendUrl = "http://60.204.152.210/seeyon/";
    //速网esb地址
    private static final String baseUrl = "http://hzya.ufyct.com:9067/kangarooDataCenter/entranceController/externalCallInterface";
    @Resource
    private ISysApplicationDatabaseDao sysApplicationDatabaseDao;
    @Autowired
    private ISysApplicationApiService sysApplicationApiService;
    /**
     * 定义所支持的事件静态代码块
     */
    private static final StringBuffer eventTypeBuffer = new StringBuffer();

    {
        eventTypeBuffer.append("发起前事件 onBeforeStart ,");
        eventTypeBuffer.append("发起事件 onStart ,");
        eventTypeBuffer.append("终止前事件 onBeforeStop ,");
        eventTypeBuffer.append("终止事件 onStop,");
        eventTypeBuffer.append("撤销前事件 onBeforeCancel,");
        eventTypeBuffer.append("撤销事件 onCancel,");
        eventTypeBuffer.append("结束事件 onProcessFinished,");
        eventTypeBuffer.append("处理前事件 onBeforeFinishWorkitem,");
        eventTypeBuffer.append("处理事件 onFinishWorkitem,");
        eventTypeBuffer.append("回退前事件 onBeforeStepBack,");
        eventTypeBuffer.append("回退事件 onStepBack,");
        eventTypeBuffer.append("取回前事件 onBeforeTakeBack,");
        eventTypeBuffer.append("取回事件 onTakeBack,");
    }

    //基础档案类型
    private final String ARCHIVESTYPE = "archives";
    //流程表单类型
    private final String FLOWTYPE = "flow";
    //创建基础档案
    private final String CREATEARCHIVES = "create";
    //更新基础档案
    private final String UPDATEARCHIVES = "update";
    //创建基础档案
    private final String CREATEARCHIVESURL = "rest/form/import/";
    //创建基础档案
    private final String UPDATEARCHIVESURL = "rest/form/update";
    @Resource
    private ISeeYonInterFaceDao seeYonInterFaceDao;


    /**
     * 钉钉相关接口service
     */
    @Resource
    private IDDInterfaceService iddInterfaceService;
    //上一次同步时间
    private String LAST_SYNCHRONISED_TIME = "";
    /****
     * @Content:发起无流程表单接口实现
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2019/12/23 17:03
     * @Param [templateCode 模版编码, sendLoginName 发送人登录帐号 ,xmlData  ]
     * @return java.lang.Integer
     **/
    public static JsonResultEntity saveNoProcess(String templateCode , String interfaceUrl,String sendLoginName, String xmlData) {
        String token = getToken(RESTUSERNAME, RESTPASSWORD, sendLoginName);
        Map res = new HashMap();
        res.put("loginName", sendLoginName);
        res.put("dataXml", xmlData);
        res.put("token", token);
        String result = HttpRequest.post(sendUrl + interfaceUrl + templateCode).header("token", token).body(JSON.toJSONString(res)).execute().body();
        logger.info("无流程表单执行结果：" + result);
        return BaseResult.getFailureMessageEntity("执行成功", result);
    }

    public static JsonResultEntity upDateNoProcess(String interfaceUrl, String templateCode, String sendLoginName, String moduleId, String xmlData) {
        String token = getToken(RESTUSERNAME, RESTPASSWORD, sendLoginName);
        Map res = new HashMap();
        res.put("loginName", sendLoginName);
        res.put("dataXml", xmlData);
        res.put("token", token);
        res.put("moduleId", moduleId);
        res.put("templateCode", templateCode);
        logger.info("更新无流程表单参数:{}",JSON.toJSONString(res));
        String result = HttpRequest.put(sendUrl + interfaceUrl).header("token", token).body(JSON.toJSONString(res)).execute().body();
        logger.info("更新无流程表单执行结果：" + result);
        return BaseResult.getFailureMessageEntity("执行成功", result);
    }

    //    {
//        "moduleId":"5701605966502512923",
//            "templateCode":"formmain_0360",
//            "loginName":"seeyon",
//            "dataXml":"<forms  version=\"2.1\"><formExport><summary  id=\"7382733425750590212\" name=\"formmain_0360\"/><definitions><column  id=\"field0001\" type=\"0\" name=\"供应商编码\" isNullable=\"false\" length=\"100\"/><column  id=\"field0002\" type=\"0\" name=\"供应商名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0007\" type=\"0\" name=\"税号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0008\" type=\"0\" name=\"地址\" isNullable=\"false\" length=\"100\"/><column  id=\"field0009\" type=\"0\" name=\"电话\" isNullable=\"false\" length=\"100\"/><column  id=\"field0011\" type=\"0\" name=\"联系人\" isNullable=\"false\" length=\"100\"/></definitions><values><column  name=\"供应商编码\"><value><![CDATA[ 12345 ]]></value></column><column  name=\"供应商名称\"><value><![CDATA[ 测试客户银行1111 ]]></value></column><column  name=\"税号\"><value><![CDATA[ 982698741E96 ]]></value></column><column  name=\"地址\"><value><![CDATA[ 杭州 ]]></value></column><column  name=\"电话\"><value><![CDATA[ null ]]></value></column><column  name=\"联系人\"><value><![CDATA[ null ]]></value></column></values><subForms><subForm><definitions><column  id=\"field0003\" type=\"4\" name=\"序号\" isNullable=\"false\" length=\"20\"/><column  id=\"field0005\" type=\"0\" name=\"开户行名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0006\" type=\"0\" name=\"银行账号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0004\" type=\"0\" name=\"是否默认\" isNullable=\"false\" length=\"100\"/></definitions><values><row><column  name=\"序号\"><value><![CDATA[1]]></value><title><![CDATA[1438373948291346275]]></title></column><column  name=\"开户行名称\"><value><![CDATA[1234]]></value><title><![CDATA[9218745623489128746]]></title></column><column  name=\"银行账号\"><value><![CDATA[111111111]]></value><title><![CDATA[6897123456789123456]]></title></column><column  name=\"是否默认\"><value><![CDATA[是]]></value><title><![CDATA[5729461284567891234]]></title></column></row></values></subForm></subForms></formExport></forms>"
//    }
    private static String getToken(String userName, String password, String loginName) {
        JSONObject jsonObject = new JSONObject();
        /** 获取token*/

        jsonObject.put("userName", userName);
        jsonObject.put("password", password);
        jsonObject.put("loginName", loginName);
        logger.info("请求获取token开始---------------------------------------------");
        logger.info("请求参数" + jsonObject.toJSONString());
        String result = HttpUtil.post(sendUrl + "rest/token", jsonObject.toJSONString());
        logger.info("获取token结果---------------------------------------------" + result);
        logger.info("获取token结果---------------------------------------------" + result);
        jsonObject = JSONObject.parseObject(result);
        if ("".equals(result) || result == null) {
            logger.info("获取token失败！");
            throw new RuntimeException("获取token失败！");
        } else {
            String token = jsonObject.get("id").toString();
            return token;
        }
    }

    /***
     * 发起OA表单方法
     * @content:
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-22 9:32
     * @param
     * @return com.hzya.frame.web.entity.BaseResult
     **/
    @Override
    public JsonResultEntity thirdInterfaceSend(JSONObject requestData) {
        JSONObject jsonStr = requestData.getJSONObject("jsonStr");
        if (ObjectUtils.isEmpty(jsonStr)) {
            throw new BaseSystemException("jsonStr为空！请传递参数");
        }
        //类型 flow archives
        String type = jsonStr.getString("type");
        if (StringUtils.isEmpty(type)) {
            throw new BaseSystemException("请传递类型！type 流程表单：flow 基础档案：archives");
        }
        //模版编号
        String templateCode = jsonStr.getString("templateCode");
        if (StringUtils.isEmpty(templateCode)) {
            throw new BaseSystemException("请传入模版编号！templateCode不允许为空");
        }
        JSONObject data = jsonStr.getJSONObject("data");
        String attributeArrayStr = jsonStr.getString("attribute");
        if (StringUtils.isEmpty(attributeArrayStr)) {
            throw new BaseSystemException("attribute不允许为空");
        }
        List<JSONObject> attributeArray = JSON.parseArray(attributeArrayStr, JSONObject.class);
        JsonResultEntity result = null;
        if (ARCHIVESTYPE.equalsIgnoreCase(type)) {
            switch (templateCode){
                //预留的
                case "abc123":
                    break;
            }
        }
        if (FLOWTYPE.equalsIgnoreCase(type)) {
        }
        return result;
    }


    @Override
    public JsonResultEntity thirdInterfaceSeeYonPlugInInterfaceEntrance(JSONObject requestData){
        String jsonStr = requestData.getString("jsonStr");
        JSONObject jsonObject = requestData.getJSONObject("jsonStr");
        OAWorkflowEventDataEntity entity = JSON.parseObject(jsonStr,OAWorkflowEventDataEntity.class);
        logger.info("监听OA事件入参："+jsonObject.toJSONString());
        JSONObject formBeanData = jsonObject.getJSONObject("businessDataStr");
        String eventType = jsonObject.getString("eventType") ;
        /** 流程ID*/
        String summaryId = entity.getSummaryId();
        /** 节点ID*/
        String affairId = entity.getAffairId();
        String currentActivityId = entity.getCurrentActivityId();
        /****/
        String formViewOperation = entity.getFormViewOperation();
        Object summaryObj = entity.getSummaryObj();
        String deeCfgId = entity.getDeeCfgId();
        String currentNodeLast = entity.getCurrentNodeLast();
        Map<String, Object> businessData = JSON.parseObject(entity.getBusinessDataStr(), Map.class);
        Map<String, Object> extData = entity.getExtData();
        /** 表单表的FORM ID,用此字段标记是哪个流程*/
        String formApp = entity.getFormApp();

        //formApp 最好过滤一下


        String result = null;
        try {
            //流程事件处理
            result = colEventPost(jsonStr, formApp, eventType);
        }catch (Exception e){
            return BaseResult.getFailureMessageEntity("传递失败",e.getMessage());
        }
        try {
            /** 根据事件类型处理相关事件*/
            switch (eventType) {
                /** 发起前事件*/
                case "onBeforeStart":
                    break;
                /** 发起事件*/
                case "onStart":
                    //流程发起 新增grpu8单据
                    break;
                /** 终止前事件*/
                case "onBeforeStop":
                    break;
                /** 终止事件*/
                case "onStop":
                    //流程终止，更新grpu8单据
                    break;
                /** 撤销前事件*/
                case "onBeforeCancel":
                    break;
                /** 撤销事件*/
                case "onCancel":
                    //流程撤销，更新grpu8单据
                    break;
                /** 结束事件*/
                case "onProcessFinished":
                    break;
                /** 处理前事件*/
                case "onBeforeFinishWorkitem":
                    /** 根据form处理相关业务表单的数据*/
                    switch (formApp) {
                        case "abc123":
                            break;
                        default:
                            return   BaseResult.getFailureMessageEntity("未匹配到表单！当前formID：" + formApp,  "");
                    }
                    break;
                /** 处理事件*/
                case "onFinishWorkitem":
                    break;
                /** 回退前事件*/
                case "onBeforeStepBack":
                    break;
                /** 回退事件*/
                case "onStepBack":
                    break;
                /** 取回前事件*/
                case "onBeforeTakeBack":
                    break;
                /** 取回事件*/
                case "onTakeBack":
                    break;
                default:
//                throw new RuntimeException("传入了非法事件类型！请参照：" + eventTypeBuffer.toString());
                    return   BaseResult.getFailureMessageEntity("传入了非法事件类型！请参照：" + eventTypeBuffer.toString(), "", "");
            }
            return BaseResult.getSuccessMessageEntity("传递成功",  result);
        }catch (Exception e){
            return BaseResult.getFailureMessageEntity("传递失败",e.getMessage());
        }
    }


    @Override
    public JsonResultEntity thirdInterfaceSeeYonDefinitionRePush(JSONObject jsonObject) throws Exception {
        JSONObject requestData = jsonObject.getJSONObject("jsonStr");
        JSONArray resultEntityArray = new JSONArray();
        if(null == requestData){
            throw  new BaseSystemException("参数传递错误需要jsonStr!");
        }
        //表单模版ID
        String formAppId = requestData.getString("formAppId");
        //事件事件类型
        String eventType = requestData.getString("eventType");
        //数据源编码
        String dataSourceCode = requestData.getString("dataSourceCode");
        //主表ID集合 formMainIds
        JSONArray formMainIds = requestData.getJSONArray("formMainIds");
        if(StrUtil.isEmpty(eventType)){
            throw  new BaseSystemException("需要传递eventType 参照致远OA事件!");
        }
        if(StrUtil.isEmpty(formAppId)){
            throw  new BaseSystemException("需要传递formAppId 参照致远OA 表 CAP_FORM_DEFINITION!");
        }
        if(StrUtil.isEmpty(dataSourceCode)){
            throw  new BaseSystemException("需要传递dataSourceCode 参照中台表 sys_data_source!");
        }
        if(null == formMainIds || formMainIds.size() == 0){
            throw  new BaseSystemException("需要传递业务主表数据id集合,不允许全量推送!");
        }

        SeeYonInterFaceEntity seeYonInterFaceEntity = new SeeYonInterFaceEntity();
        BeanUtil.copyProperties(requestData,seeYonInterFaceEntity);
        List<SeeYonInterFaceEntity> seeYonInterFaceEntityList = seeYonInterFaceDao.queryDefinitionInfo(seeYonInterFaceEntity);
        if(null != seeYonInterFaceEntityList && seeYonInterFaceEntityList.size() >0){
            for(SeeYonInterFaceEntity interFaceEntity : seeYonInterFaceEntityList){
                String field_info = interFaceEntity.getField_info();
                JSONObject infoJson = JSON.parseObject(field_info);
                //获取主表信息
                JSONObject formMain = infoJson.getJSONObject("front_formmain");
                //获取明细表信息
                JSONArray formSons = infoJson.getJSONArray("formsons");
                //主表tableName
                String formMainTableName = formMain.getString("tableName");

                /** 设置主表查询条件*/
                interFaceEntity.setTabName(formMainTableName);
                interFaceEntity.setDataSourceCode(dataSourceCode);
                interFaceEntity.setFormMainIds( formMainIds.toJavaList(String.class) );

                List<Map<String, Object>> forMainList = seeYonInterFaceDao.queryDefinitionData(interFaceEntity);
                for (Map<String, Object> forMainRow : forMainList) {
                    //定义致远OA事件对象
                    JSONObject seeYonBean = new JSONObject();
                    //定义主表对象
                    JSONObject formMainObj = new JSONObject();
                    //获取主表ID
                    String forMainId = String.valueOf(forMainRow.get("ID"));
                    //组装主表数据
                    for (Map.Entry<String, Object> entry : forMainRow.entrySet()) {
                        formMainObj.put(entry.getKey().toLowerCase(),entry.getValue());
                     }
                    //组装明细表数据
                    if(null != formSons && formSons.size() > 0){
                        for(Object formSon : formSons){
                            JSONObject son = JSON.parseObject(JSON.toJSONString(formSon));
                            //明细数据
                            String sonTableName = son.getString("tableName");
                            SeeYonInterFaceEntity details = new SeeYonInterFaceEntity();
                            details.setFormMainId(forMainId);
                            details.setTabName(sonTableName);
                            details.setDataSourceCode(dataSourceCode);
                            JSONArray jsonArray = new JSONArray();
                            List<Map<String, Object>> forSonList = seeYonInterFaceDao.queryDefinitionData(details);
                            for (Map<String, Object> forSons : forSonList) {
                                //组装明细数据
                                JSONObject forSonJson = new JSONObject();
                                for (Map.Entry<String, Object> entry : forSons.entrySet()) {
                                    forSonJson.put(entry.getKey().toLowerCase(),entry.getValue());
                                 }
                                jsonArray.add(forSonJson);
                            }
                            //设置明细表数据
                            seeYonBean.put(sonTableName,jsonArray);
                        }
                    }

                    seeYonBean.put(formMainTableName,formMainObj);
                    JSONObject rePushRequestData = new JSONObject();
                    JSONObject object = new JSONObject();
                    object.put("formApp",formAppId);
                    object.put("eventType",eventType);
                    object.put("businessDataStr",seeYonBean.toJSONString());
                    object.put("affairId","");
                    object.put("summaryId",requestData.getString("summaryId"));
                    object.put("currentActivityId","");
                    object.put("id",forMainId);
                    object.put("hzyaExtData",requestData.getJSONObject("hzyaExtData"));
                    logger.info("Method:thirdInterfaceSeeYonDefinitionRePush 组装seeYonBean DATA: {}",seeYonBean.toJSONString());

                    rePushRequestData.put("jsonStr",object);


                    JsonResultEntity  resultEntity = thirdInterfaceSeeYonPlugInInterfaceEntrance(rePushRequestData);
                    if(null != resultEntity){
                        resultEntityArray.add(resultEntity.getAttribute());
                    }else{
                        JSONObject jsonResultEntity  = new JSONObject();
                        jsonResultEntity.put("msg","从新推送失败");
                        jsonResultEntity.put("id",forMainId);
                        resultEntityArray.add(jsonResultEntity);

                    }

                }
            }
        }
        return BaseResult.getSuccessMessageEntity("从新推送执行结束",resultEntityArray);
    }

    /**
     * seeyon流程事件监听前置方法，绑定数据源
     * @param entity
     * @return
     * @throws Exception
     */
    @Override
    public SysExtensionApiEntity colEventPre(SysExtensionApiEntity entity) throws Exception {
        try {
            SysApplicationEntity applicationEntity = entity.getSendApp();
            SysApplicationDatabaseEntity sysApplicationDatabaseEntity = new SysApplicationDatabaseEntity();
            sysApplicationDatabaseEntity.setSts("Y");
            sysApplicationDatabaseEntity.setDbStatus("1");
            sysApplicationDatabaseEntity.setAppId(applicationEntity.getId());
            sysApplicationDatabaseEntity.setDataSourceCode("master");
            List<SysApplicationDatabaseEntity> sysDataSourceEntities = sysApplicationDatabaseDao.queryDSBase(sysApplicationDatabaseEntity);
            if(sysDataSourceEntities != null && sysDataSourceEntities.size() > 0){
                String parm = entity.getBodys();
                JSONObject jsonObject = JSONObject.parseObject(parm);
                jsonObject.put("dataSourceCode",sysDataSourceEntities.get(0).getSourceCode());
                entity.setBodys(jsonObject.toJSONString());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return entity;
    }

    /**
     * seeyon流程事件监听
     *
     * @param jsonObject
     * @return
     * @throws Exception
     */
    @Override
    public JsonResultEntity colEventListener(JSONObject jsonObject) throws Exception {
        try {
            if (null != jsonObject && StrUtil.isNotEmpty(jsonObject.getString("jsonStr"))){
                SeeYonInterFaceEntity entity = jsonObject.getJSONObject("jsonStr").toJavaObject(SeeYonInterFaceEntity.class);
                JSONObject requestData = new JSONObject();
                //表单模版ID
                requestData.put("formAppId", entity.getFormAppId());
                //事件事件类型
                requestData.put("eventType",entity.getEventType());
                //数据源编码
                requestData.put("dataSourceCode",entity.getDataSourceCode());
                requestData.put("formMainIds",entity.getFormMainIds());
                requestData.put("summaryId",entity.getSummaryId());
                JSONObject jsonStr = new JSONObject();
                jsonStr.put("jsonStr",requestData);
                thirdInterfaceSeeYonDefinitionRePush(jsonStr);
            }
        }catch (Exception e){
            logger.error("流程事件通知接口出错:{}",e);
            return BaseResult.getSuccessMessageEntity("失败",e.getMessage());
        }
        return BaseResult.getSuccessMessageEntity("成功");
    }

    /**
     * seeyon流程事件监听后置方法，调用三方接口
     *
     * @param jsonStr
     * @param formAppId
     * @param eventType
     * @return
     * @throws Exception
     */
    @Override
    public String colEventPost(String jsonStr, String formAppId, String eventType) throws Exception {
        if (StrUtil.isNotEmpty(jsonStr) && StrUtil.isNotEmpty(formAppId) && StrUtil.isNotEmpty(eventType)){
            SysApplicationApiEntity sysApplicationApiEntity = new SysApplicationApiEntity();
            sysApplicationApiEntity.setHeaderIn(formAppId+"_"+eventType);
            List<SysApplicationApiEntity> applist = sysApplicationApiService.queryLike(sysApplicationApiEntity);
            if (CollectionUtil.isNotEmpty(applist)){
                if (applist.size() > 1){
                    throw new BaseSystemException("根据formID：" + formAppId+"查询出多条数据");
                }
                SysApplicationApiEntity sysApp = applist.get(0);
                Map<String, String> headerMap = MapBuilder.<String, String>create(true)
                        .put("apiCode", String.valueOf(sysApp.getApiCode()))
                        //这里用中台做为发送方
                        .put("publicKey","ZJYAWb7lhAUTYqekPkU+uHJv1/ObJxb7dT7sD8HPRDGAgyhCe7eDIk+3zDUT+v578prj")
                        .put("secretKey","fviZnLBsQUAGF8w8FSOdJi7XlIm/XAZclMxRagDLfTyJFlvnIBF3w66Hrpfzs8cYj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")
                        .put("appId",String.valueOf(sysApp.getAppCode()))
                        .build();
                String body = HttpRequest.post("http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface").addHeaders(headerMap).body(jsonStr).timeout(60000).execute().body();
                logger.info("调用中台返回的参数:{}",body);
                return body;
            }
        }
        return null;
    }
}
